/* Automatically generated by mknewcmd on Fre Nov 30 05:45:31 CET 2018
 * This is machine generated output. The author of mknewcmd claims no
 * copyright over the contents of this file. Where legally permitted, the
 * contents herein are donated to the public domain.
 *
 * You should apply any license and copyright that you wish to this file,
 * replacing this header in its entirety. */

#include <stdio.h>
#include <stdlib.h>
#include <str.h>
#include <adt/odict.h>

#include "config.h"
#include "util.h"
#include "errors.h"
#include "entry.h"
#include "unalias.h"
#include "cmds.h"



static const char *cmdname = "unalias";



static void free_alias(odlink_t *alias_link)
{
	alias_t *data = odict_get_instance(alias_link, alias_t, odict);
	odict_remove(alias_link);

	free(data->name);
	free(data->value);
	free(data);
}


/* Dispays help for unalias in various levels */
void help_cmd_unalias(unsigned int level)
{
	printf("`%s' removes an alias or all aliases with -a\n", cmdname);
	return;
}


/* Main entry point for unalias, accepts an array of arguments */
int cmd_unalias(char **argv)
{

	if(argv[1] == NULL) {
		help_cmd_unalias(HELP_LONG);
		return CMD_SUCCESS;
	}

	size_t i;
	odlink_t *alias_link;

	for (i = 1; argv[i] != NULL; i++) {
		if (str_cmp(argv[i], "-a") == 0) {
			alias_link = odict_first(&alias_dict);
			while (alias_link != NULL) {
				odlink_t *old_alias_link = alias_link;
				alias_link = odict_next(old_alias_link, &alias_dict);
				free_alias(old_alias_link);
			}

			return CMD_SUCCESS;
		}


		alias_link = odict_find_eq(&alias_dict, (void*)argv[i], NULL);

		if (alias_link == NULL) {
			printf("%s: No alias '%s' found\n", cmdname, argv[i]);
			return CMD_FAILURE;
		}

		free_alias(alias_link);
	}

	
	
	return CMD_SUCCESS;
}

